/*
	File:		ListEx1PartDef.h

	Contains:	Common definitions used by ListEx1Part.cpp & .r files.

	Written by:	Steve Smith

	Copyright:	 1994-95 by Apple Computer, Inc., all rights reserved.
	
	-------------------------------------------------------------------
	
	Note:		This file will need to be modified for any derivitive
				work based on ListEx1Part. The areas marked with (CH)
				should be considered when making those changes.
*/


#ifndef _LISTEX1PARTDEF_
#define _LISTEX1PARTDEF_

// -- OpenDoc Includes --

#ifndef SOM_Module_OpenDoc_StdDefs_defined
#include <StdDefs.xh>
#endif

//=====================================================================

// Class / Editor ID (CH)
#define kPartClassName					"som_ListEx1Part"
#define kListEx1PartID					"ACF_DevServ2::"kPartClassName

// Editor User String (CH)
#define kListEx1PartEditorUserString 	"ListEx1Part 1.0"

// Kind (CH)
#define kListEx1PartKind				kODISOPrefix "Apple:Kind:ListEx1Part"

// Kind User String (CH)
#define kListEx1PartKindUserString		"ListEx1Part"

// Category (CH)
#define kListEx1PartCategory			kODISOPrefix "Apple:Category:List Data"

// Category User String (CH)
#define kListEx1PartCategoryUserString 	"List Data"

// ListEx1Part OSTypes (CH)
#define kListEx1PartEditorOSType		'L'
#define kListEx1PartViewerOSType		'L'
#define kListEx1PartDocumentOSType		'DL'
#define kListEx1PartStationeryOSType	'sL'

// ISO Strings (CH)
#define kMainPresentation  				kODISOPrefix "ListEx1Part:Presentation:Main"
#define kListEx1PartInfo				kODISOPrefix "ListEx1Part:Display Frame Info"

// ListEx1Part defines
#define	kBaseResourceID					20001

// NMAP Resource IDs
#define kKindCategoryMapId				kBaseResourceID+1
#define kEditorKindMapId				kBaseResourceID+2
#define kEditorUserStringMapId			kBaseResourceID+3
#define kKindUserStringMapId			kBaseResourceID+4
#define kCategoryUserStringMapId		kBaseResourceID+5
#define kOldMacOSTypeMapId				kBaseResourceID+6

// Text Items
#define	kMenuStringResID				kBaseResourceID
#define	kAboutTextID        			1
#define	kDefaultContent1ID				2
#define	kDefaultContent2ID				3

// Error Messages
#define kErrorStringResID				kMenuStringResID+1
#define kErrStrFieldID					3
#define kErrCantInitializePart			1
#define kErrCantOpenDocWindow			2
#define kErrCantOpenPartWindow			3
#define kErrRemoveFrame					4
#define kErrWindowGone					5
#define kErrExternalizeFailed			6

// Bundles/FREFs
#define kDocumentBundle					kBaseResourceID
#define kEditorBundle					kBaseResourceID+1
#define kViewerBundle					kBaseResourceID+2
#define kDocumentFREF					kBaseResourceID
#define kStationeryFREF					kBaseResourceID+1
#define kEditorFREF						kBaseResourceID+2
#define kViewerFREF						kBaseResourceID+3

// Icons
#define	kLargeIcons						1
#define	kSmallIcons						2
#define	kDocumentIcons					kBaseResourceID
#define	kStationeryIcons				kBaseResourceID+1
#define	kEditorIcons					kBaseResourceID+2
#define	kViewerIcons					kBaseResourceID+3

// Pictures
#define kEditorIconPicture				kBaseResourceID
#define	kThumbnailPicture				kBaseResourceID+1

// Dialogs & Windows
#define	kAboutBoxID  					kBaseResourceID
#define	kErrorBoxID  					kBaseResourceID+1
#define	kMacWindowTitleBarHeight		20
#define	kALittleNudge					4
#define kMinVertVisPortion				10
#define kMinHorzVisPortion				16

// Display Frames
#define kFrameRemoved					1
#define kFrameClosed					0

// Geometry
#define kMinImagingResolution			72 // dpi

#endif

