
#include "stdio.h"

#ifndef _LISTEX3PART_
#include "ListEx3Part.h"
#endif

#ifndef _LISTEX3PARTDEF_
#include "ListEx3PartDef.h"
#endif

#ifndef _USERSRCM_
#include "UseRsrcM.h"
#endif

#ifndef _ODUTILS_
#include "ODUtils.h"
#endif

typedef void (*funcptr)(ODPart*, Environment*, ODFrame*, ODUShort);

char gEmptyString[] = "";
char gClassName[] = "ClassName = ";
char gNumOfMethods1[] = "Number of methods = ";
char gNumOfMethods[15];
char gMethodID[] = "MethodId = ";
char gMethodDes[] = "MethodDescriptor = ";

//----------------------------------------------------------------------------------------

ODISOStr GetTheRealPartKind(Environment* ev)
	{ return kListEx3PartKind; }

ODSLong OverrideBeginUsingLibraryResources(Environment* ev)
	{ return BeginUsingLibraryResources(); }

void OverrideEndUsingLibraryResources(Environment* ev, ODSLong ref)
	{ EndUsingLibraryResources(ref); }

void InitializeListData(Environment *ev,
		short* pNbLines,
		short* pLineHeight,
		short* pLineWidth,
		short* pLineDepth,
		short* pKind,
		short* pAutoThumb,
		short* pWantKey,
		short* pListIndex,
		short* pSel,
		char** pMul)
	{
	*pNbLines = NBLINES / 2;
	*pLineHeight = 24;
	*pLineWidth = 400;
	*pLineDepth = 8;
	*pKind = 2;
	*pAutoThumb = 1;
	*pWantKey = 1;
	*pListIndex = 300;
	*pMul = 0L;
	}

void FacetAdded(Environment *ev, ODFacet* facet, ODPart* *theContainingPart, char** theArray)
	{
	short theLine = 0;
	char *theClassName;
	ODFrame* containingFrame;
	SOMClass* theClass = kODNULL;
	ODPart* locPart = kODNULL;
	somKernelId theKernelID;
	somId theSomID;

	if ((*theContainingPart) == kODNULL)
		{
		for(short i=0;i<NBLINES;i++) theArray[i] = gEmptyString;
		containingFrame = facet->GetFrame(ev)->AcquireContainingFrame(ev);
		if (containingFrame) (*theContainingPart) = containingFrame->AcquirePart(ev); /* This is in fact a PartWrapper ! */
		if ((*theContainingPart) != kODNULL)
			{
			if (!((*theContainingPart)->IsRealPart(ev)))
				{
				locPart = (*theContainingPart);
				(*theContainingPart) = locPart->GetRealPart(ev); /* To get the real Part */
				}
			if ((*theContainingPart) != kODNULL) theClassName = (*theContainingPart)->somGetClassName();
			if (theClassName != kODNULL)
				{
				theArray[theLine] = (char *)gClassName; theLine++;
				theArray[theLine] = (char *)theClassName; theLine++;
				}
			if ((*theContainingPart) != kODNULL) theClass = (*theContainingPart)->somGetClass();
			if (theClass != kODNULL)
				{
				long nbOfMethods = theClass->somGetNumMethods();
				theArray[theLine] = (char *)gNumOfMethods1; theLine++;
				sprintf(gNumOfMethods, "%ld", nbOfMethods);
				theArray[theLine] = (char *)gNumOfMethods; theLine++;
				for(long i = 0; i < nbOfMethods; i++)
					{
					theClass->somGetNthMethodInfo(i, &theKernelID);
					theSomID = somConvertAndFreeKernelId(theKernelID);
					char *theMethodid = somMakeStringFromId(theSomID);
					theArray[theLine] = (char *)gMethodDes; theLine++;
					theArray[theLine] = (char *)theMethodid; theLine++;
					SOMFree(theSomID);
					}
					{ // Quick and dirty test. Will work only if embedded in Container !
					funcptr callit = (funcptr)somResolveByName((*theContainingPart), "SetBGColor1");
					if (callit) (*callit)((*theContainingPart), ev, containingFrame, 3);
					}
				}
			if (locPart) locPart->ReleaseRealPart(ev);
			}
		if (*theContainingPart) (*theContainingPart)->Release(ev);
		if (containingFrame) containingFrame->Release(ev);
		}
	}

void SetUpGraphics(Environment *ev, GWorldPtr theGWorld)
	{
	CGrafPtr port;
	GDHandle gdh;

	GetGWorld(&port, &gdh);
	SetGWorld(theGWorld, 0L);
	TextFont(1);
	TextSize(9);
	SetGWorld(port, gdh);
	}

void FillCell(Environment *ev, short theLine, Rect* theRect, char** theArray)
	{
	Str255 aStr, str1, str2;
	RGBColor myBlack = {0, 0, 0}, myLightGreen = {0xb000, 0xE000, 0xb000}, myLightRed = {0xE000, 0xb000, 0xb000};

	PenState thePnState;
	::GetPenState(&thePnState);
	::PenNormal();
	::EraseRect(theRect);
	::RGBForeColor(((theLine & 1) == 0)?(&myLightGreen):(&myLightRed));
	::PaintRect(theRect);
	::RGBForeColor(&myBlack);
	::sprintf((char *)aStr, "%.3d ", theLine);
	::BlockMove((Ptr)theArray[2*(theLine-1)], (Ptr)str1, 256);
	::BlockMove((Ptr)theArray[(2*(theLine-1))+1], (Ptr)str2, 256);
	::strcat((char *)aStr, (char *)str1);
	::strcat((char *)aStr, (char *)str2);
	::c2pstr((char *)aStr);
	::MoveTo(theRect->left+1, theRect->bottom-3);
	::DrawString(aStr);
	::SetPenState(&thePnState);
	}
