/*
	File:		som_ListEx3PartInit.cpp

	Contains:	Symantec Entry points for init functions

*/



// -- Compiler/Preprocessor Switches --

#ifndef _COMPILERDEFS_
#include "CompDefs.h"
#endif

// -- OpenDoc Utilities --

#ifndef _EXCEPT_
// Exceptions define several important macros (ie. CHECKENV)
// which are used in the SOM method dispatch glue. If Except.h
// is not included early enough, exceptions may not be thrown
// correctly when returning from a SOM method with "ev" parameter set.
#include <Except.h>
#endif

// -- SOM Includes --

#ifndef som_xh
#include <som.xh>
#endif

#ifndef SOM_SOMObject_xh
#include <somobj.xh>
#endif

// -- ListEx3Part Includes --

#ifndef SOM_ACF_DevServ4_som_ListEx3Part_xh
#include "som_ListEx3Part.xh"
#endif

// -- OpenDoc Utilities --

#ifndef _USERSRCM_
#include <UseRsrcM.h>
#endif

#ifndef _ODMEMORY_
#include <ODMemory.h>
#endif

// -- MacToolbox Includes --

#ifndef __CODEFRAGMENTS__
#include <CodeFragments.h>
#endif

#pragma segment somListEx3PartInit

//------------------------------------------------------------------------------
// Prototypes
//------------------------------------------------------------------------------

// Adkins -- InitBlockPtr was change to CFragInitBlockPtr for CFMInit entry points post DR3.

	// Apple entry points
//SOMEXTERN void SOMLINK ListEx3PartSOMInit(long, long, corbastring ); //Adkins -- no longer needed in DR4
extern "C" pascal OSErr ListEx3PartCFMInit(CFragInitBlockPtr initBlkPtr);
	// SC++ 8.0 entry points
//SOMEXTERN void SOMLINK main(long, long, string ); //Adkins -- no longer needed in DR4
extern "C" pascal OSErr PartCFMInit(CFragInitBlockPtr initBlkPtr);


//------------------------------------------------------------------------------
// Functions
//------------------------------------------------------------------------------

/* //Adkins -- no longer needed in DR4
SOMEXTERN void SOMLINK main(long majorVersion,
								long minorVersion, 
								string className)
{
	ListEx3PartSOMInit(majorVersion, minorVersion, className);
}*/

extern "C" pascal OSErr PartCFMInit(CFragInitBlockPtr initBlkPtr)
{
	return ListEx3PartCFMInit(initBlkPtr);
}
