/*
	File:		SuperFlyToolWindow.h

	Contains:	A window that displays information about a GDevice
				
	Written by: Kent Miller
	
	Copyright:	 1996 Apple Computer

	Change History (most recent first):

 */


#ifndef		_SUPERFLYTOOLWINDOW_
#define		_SUPERFLYTOOLWINDOW_

#ifndef		_WINDOW_
#include	"Window.h"
#endif

#ifndef		_DISPLAYS_
#include	<Displays.h>
#endif

#define		kIconBase		2048
#define		kNumIcons		6
#define 	kToolButtonSize 64
#define 	kNamesID		129
#define 	PinAtZero(x) (x<0)? 0:x;

class	TSuperFlyToolWindow	:	public TWindow
	{
protected:
public:
							TSuperFlyToolWindow();
	virtual 				~TSuperFlyToolWindow();

//Overridden methods
	virtual void			Drag(Point startPoint);

	virtual WindowPtr		MakeNewWindow(WindowPtr behindWindow);
	virtual void			Draw(void);
	virtual void			Click(EventRecord * anEvent);
	virtual	Boolean			Close();

//New methonds
	void					CalculateRelativePosition(void);
	void					MoveToRelativePosition(void);

private:
	Rect				oldScreenRect;
	Rect				myStrucRect;
	DisplayIDType		theID;  //Even though GDHandles might change, the Display Manager
	};


#endif
